"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.getSchemaPreview = exports.byCodeQuerySchema = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _assets = _interopRequireDefault(require("./assets.json"));
var _lowcodeUtils = require("@alilc/lowcode-utils");
var _lowcodePluginInject = require("@alilc/lowcode-plugin-inject");
var _axios = _interopRequireDefault(require("axios"));
var getSchemaPreview = exports.getSchemaPreview = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(_ref) {
    var _ref$dataSource, dataSource, packages, componentsMapArray, componentsTree, i18n, componentsMap, schema, libraryMap, libraryAsset, assetLoader, components;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          _ref$dataSource = _ref.dataSource, dataSource = _ref$dataSource === void 0 ? {} : _ref$dataSource;
          if (Object.keys(dataSource).length) {
            _context.next = 3;
            break;
          }
          return _context.abrupt("return", {});
        case 3:
          packages = _assets["default"].packages;
          componentsMapArray = dataSource.componentsMap, componentsTree = dataSource.componentsTree, i18n = dataSource.i18n;
          componentsMap = {};
          componentsMapArray.forEach(function (component) {
            componentsMap[component.componentName] = component;
          });
          schema = componentsTree[0];
          libraryMap = {};
          libraryAsset = [];
          packages.forEach(function (_ref3) {
            var _package = _ref3["package"],
              library = _ref3.library,
              urls = _ref3.urls,
              renderUrls = _ref3.renderUrls;
            libraryMap[_package] = library;
            if (renderUrls) {
              libraryAsset.push(renderUrls);
            } else if (urls) {
              libraryAsset.push(urls);
            }
          });
          // TODO asset may cause pollution
          assetLoader = new _lowcodeUtils.AssetLoader();
          _context.next = 14;
          return assetLoader.load(libraryAsset);
        case 14:
          _context.next = 16;
          return (0, _lowcodePluginInject.injectComponents)((0, _lowcodeUtils.buildComponents)(libraryMap, componentsMap));
        case 16:
          components = _context.sent;
          return _context.abrupt("return", {
            schema: schema,
            components: components,
            i18n: i18n
          });
        case 18:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function getSchemaPreview(_x) {
    return _ref2.apply(this, arguments);
  };
}();
var byCodeQuerySchema = exports.byCodeQuerySchema = function byCodeQuerySchema(code) {
  return _axios["default"].request({
    url: "http://sso.lowcode.net.cn:9008/low-code/schema/query/by/" + code,
    method: 'GET'
  });
};